/**
 *
 * @author Jens Weller
 * @abstract A C++11 Wordcounting implemenation
 * (c) 2013
 * @license boost software license
 * http://meetingcpp.com
 *
 **/

#include <iostream>

#include <vector>
#include <chrono>

#include "wordcounter.h"

int main(int argc, char* argv[])
{
    size_t num_cores = std::thread::hardware_concurrency();// 1
    std::cout << "Programm running on " << num_cores << " Processor cores" << std::endl;
    std::vector<WordCounter> cores(num_cores < argc? num_cores:argc);// 2
    wordcontainer wordcount;// 3

    auto t1 = std::chrono::high_resolution_clock::now();// 4
    for(size_t i = 1,j=0; i < argc;++j)//5
    {
        if(j == cores.size())//6
            j =0;
        if(!cores[j].isRunning())//7
        {
            cores[j].copyWords(wordcount);
            cores[j].startCounting(std::string(argv[i]));
            ++i;
        }
    }
    for(WordCounter& w: cores)//8
    {
        w.join();
        w.copyWords(wordcount);
    }
    auto t2 = std::chrono::high_resolution_clock::now();//9
    std::cout << "found " << wordcount.size() << " words" <<std::endl;
    std::cout << "Calculation took " << std::chrono::duration_cast<std::chrono::milliseconds>(t2-t1).count() << " milliseconds" << std::endl;
    /*for(std::pair<const std::string, size_t>& p: wordcount)
    {
        std::cout << p.first << " : " << p.second << std::endl;
    }*/
}

